﻿ArkInventoryRules_GFM = LibStub( "AceAddon-3.0" ):NewAddon( "ArkInventoryRules_GFM" )

local rule = ArkInventoryRules:NewModule( "ArkInventoryRules_Example" )

function rule:OnEnable( )

	-- Registers the functions with the main mod	
	local registered
		
	registered = ArkInventoryRules.Register( self, "gfm", rule.execute_gfm )
	
	registered = ArkInventoryRules.Register( self, "tfm", rule.execute_tfm )

	-- note: if you require another mod to be loaded you will need to add it in the .toc file
	-- in which case make sure you check that that mod actually got loaded (it might not be installed)
	
end

function rule.execute_gfm( ... )

	-- Checks that the AI Core mod is fully loaded before assessing items. If variable calls return nil values (AI is still loading) it will abort until AI is fully initialized. 
	if select( 15, ArkInventory.ObjectInfo( ArkInventoryRules.Object.h ) ) == nil or not ArkInventoryRules.Object.h or ArkInventoryRules.Object.class ~= "item" then
		return false
	end
		
	local fn = "gfm" -- The rule name, needs to be set so that error messages are readable
	
	local ac = select( '#', ... )
	
	local class = ArkInventory.Global.Me.data.info.class
	
	local objecttype = string.lower( select( 15, ArkInventory.ObjectInfo( ArkInventoryRules.Object.h ) ) ) 
	local objectsubtype = string.lower( select( 16, ArkInventory.ObjectInfo( ArkInventoryRules.Object.h ) ) )
	local objectequip = string.lower ( select( 11, ArkInventory.ObjectInfo( ArkInventoryRules.Object.h ) ) )
	
	if objecttype == "trinket" then return true end
	
	if objecttype == "armor" then
		
		if objectsubtype == "miscellaneous" then return true end
		if objectequip == "invtype_cloak" then return true end
		if objectequip == "invtype_trinket" then return true end
		if objectequip == "invtype_neck" then return true end
		if objectequip == "invtype_finger" then return true end
	
		if ( ( class == "WARRIOR" ) and ( objectsubtype == "plate") ) then return true end
		if ( ( class == "WARRIOR" ) and ( objectsubtype == "shields") ) then return true end
		if ( ( class == "DEATHKNIGHT" ) and ( objectsubtype == "plate") ) then return true end
		if ( ( class == "PALADIN" ) and ( objectsubtype == "plate") ) then return true end
		if ( ( class == "PALADIN" ) and ( objectsubtype == "shields") ) then return true end
		if ( ( class == "PRIEST" ) and ( objectsubtype == "cloth") ) then return true end
		if ( ( class == "MAGE" ) and ( objectsubtype == "cloth") ) then return true end
		if ( ( class == "WARLOCK" ) and ( objectsubtype == "cloth") ) then return true end
		if ( ( class == "HUNTER" ) and ( objectsubtype == "mail") ) then return true end
		if ( ( class == "SHAMAN" ) and ( objectsubtype == "mail") ) then return true end
		if ( ( class == "SHAMAN" ) and ( objectsubtype == "shields") ) then return true end
		if ( ( class == "DRUID" ) and ( objectsubtype == "leather") ) then return true end
		if ( ( class == "ROGUE" ) and ( objectsubtype == "leather") ) then return true end
		if ( ( class == "MONK" ) and ( objectsubtype == "leather") ) then return true end
		if ( ( class == "DEMONHUNTER" ) and ( objectsubtype == "leather") ) then return true end
	end
	
	if objecttype == "weapon" then
		
		if ( class == "DEMONHUNTER" ) and ( 
			( objectsubtype == "warglaives") or
			( objectsubtype == "one-handed swords") or
			( objectsubtype == "one-handed axes") or
			( objectsubtype == "one-handed maces") or
			( objectsubtype == "daggers") or
			( objectsubtype == "fist weapons")
		) then return true end
		
		if ( class == "WARRIOR" ) and ( 
			( objectsubtype == "one-handed swords") or
			( objectsubtype == "two-handed swords") or
			( objectsubtype == "one-handed axes") or
			( objectsubtype == "two-handed axes") or
			( objectsubtype == "one-handed maces") or
			( objectsubtype == "two-handed maces") or
			( objectsubtype == "daggers") or
			( objectsubtype == "polearms") or
			( objectsubtype == "fist weapons")
		) then return true end
	
		if ( class == "DEATHKNIGHT" ) and ( 
			( objectsubtype == "one-handed swords") or
			( objectsubtype == "two-handed swords") or
			( objectsubtype == "one-handed axes") or
			( objectsubtype == "two-handed axes") or
			( objectsubtype == "one-handed maces") or
			( objectsubtype == "two-handed maces") or
			( objectsubtype == "polearms")
		) then return true end
		
		if ( class == "PALADIN" ) and ( 
			( objectsubtype == "one-handed swords") or
			( objectsubtype == "two-handed swords") or
			( objectsubtype == "one-handed axes") or
			( objectsubtype == "two-handed axes") or
			( objectsubtype == "one-handed maces") or
			( objectsubtype == "two-handed maces") or
			( objectsubtype == "polearms")
		) then return true end
		
		if ( class == "PRIEST" ) and ( 
			( objectsubtype == "staves") or
			( objectsubtype == "wands") or
			( objectsubtype == "daggers") or
			( objectsubtype == "one-handed maces")
		) then return true end
		
		if ( class == "MAGE" ) and ( 
			( objectsubtype == "one-handed swords") or
			( objectsubtype == "staves") or
			( objectsubtype == "daggers") or
			( objectsubtype == "wands")
		) then return true end
		
		if ( class == "WARLOCK" ) and (
			( objectsubtype == "one-handed swords") or
			( objectsubtype == "staves") or
			( objectsubtype == "daggers") or
			( objectsubtype == "wands")
		) then return true end
		
		if ( class == "HUNTER" ) and ( 
			( objectsubtype == "crossbows") or
			( objectsubtype == "bows") or
			( objectsubtype == "guns") or
			( objectsubtype == "polearms")
		) then return true end
		
		if ( class == "SHAMAN" ) and (
			( objectsubtype == "staves") or
			( objectsubtype == "one-handed maces") or
			( objectsubtype == "two-handed maces") or
			( objectsubtype == "one-handed axes") or
			( objectsubtype == "two-handed axes") or
			( objectsubtype == "daggers") or
			( objectsubtype == "fist weapons")
		) then return true end
		
		if ( class == "DRUID" ) and (
			( objectsubtype == "staves") or
			( objectsubtype == "one-handed maces") or
			( objectsubtype == "two-handed maces") or
			( objectsubtype == "polearms") or
			( objectsubtype == "daggers") or
			( objectsubtype == "fist weapons")
		) then return true end
	
		if ( class == "ROGUE" ) and (
			( objectsubtype == "daggers") or
			( objectsubtype == "one-handed swords") or
			( objectsubtype == "one-handed axes") or
			( objectsubtype == "one-handed maces") or
			( objectsubtype == "fist weapons")
		) then return true end
		
		if ( class == "MONK" ) and (
			( objectsubtype == "one-handed axes") or
			( objectsubtype == "one-handed swords") or
			( objectsubtype == "one-handed maces") or
			( objectsubtype == "polearms") or
			( objectsubtype == "staves") or
			( objectsubtype == "fist weapons")
		) then return true end
		
	end
	
	-- always return false at the end
	return false
	
end

function rule.execute_tfm( ... )

	-- Checks that the AI Core mod is fully loaded before assessing items. If variable calls return nil values (AI is still loading) it will abort until AI is fully initialized. 
	if select( 15, ArkInventory.ObjectInfo( ArkInventoryRules.Object.h ) ) == nil or not ArkInventoryRules.Object.h or ArkInventoryRules.Object.class ~= "item" then
		return false
	end

		
	local fn = "tfm" -- The rule name, needs to be set so that error messages are readable.
	
	local ac = select( '#', ... )
	
	local class = ArkInventory.Global.Me.data.info.class
	
	local objecttype = string.lower( select( 15, ArkInventory.ObjectInfo( ArkInventoryRules.Object.h ) ) ) 
	local objectsubtype = string.lower( select( 16, ArkInventory.ObjectInfo( ArkInventoryRules.Object.h ) ) )
	local objectequip = string.lower ( select( 11, ArkInventory.ObjectInfo( ArkInventoryRules.Object.h ) ) )
	
	
	--#IDEA: Working on a collected items filter for even more awesomeness... maybe i'll just make it dependent on CanIMogIt and have it as an optional feature... 
	--local osd = ArkInventory.ObjectStringDecode( ArkInventoryRules.Object.h )
	--local id = osd[2]
	--if C_TransmogCollection.PlayerHasTransmog( id ) then return false end
	
	
	if objecttype == "trinket" then return false end
	
	if objecttype == "armor" then
		
		if objectsubtype == "miscellaneous" then return true end
		if objectequip == "invtype_cloak" then return true end
		if objectequip == "invtype_trinket" then return false end
		if objectequip == "invtype_neck" then return false end
		if objectequip == "invtype_finger" then return false end
	
		if ( ( class == "WARRIOR" ) and ( objectsubtype == "plate") ) then return true end
		if ( ( class == "WARRIOR" ) and ( objectsubtype == "shields") ) then return true end
		if ( ( class == "DEATHKNIGHT" ) and ( objectsubtype == "plate") ) then return true end
		if ( ( class == "PALADIN" ) and ( objectsubtype == "plate") ) then return true end
		if ( ( class == "PALADIN" ) and ( objectsubtype == "shields") ) then return true end
		if ( ( class == "PRIEST" ) and ( objectsubtype == "cloth") ) then return true end
		if ( ( class == "MAGE" ) and ( objectsubtype == "cloth") ) then return true end
		if ( ( class == "WARLOCK" ) and ( objectsubtype == "cloth") ) then return true end
		if ( ( class == "HUNTER" ) and ( objectsubtype == "mail") ) then return true end
		if ( ( class == "SHAMAN" ) and ( objectsubtype == "mail") ) then return true end
		if ( ( class == "SHAMAN" ) and ( objectsubtype == "shields") ) then return true end
		if ( ( class == "DRUID" ) and ( objectsubtype == "leather") ) then return true end
		if ( ( class == "ROGUE" ) and ( objectsubtype == "leather") ) then return true end
		if ( ( class == "MONK" ) and ( objectsubtype == "leather") ) then return true end
		if ( ( class == "DEMONHUNTER" ) and ( objectsubtype == "leather") ) then return true end
	end
	
	if objecttype == "weapon" then
		
		if ( class == "DEMONHUNTER" ) and ( 
			( objectsubtype == "warglaives") or
			( objectsubtype == "one-handed swords") or
			( objectsubtype == "one-handed axes") or
			( objectsubtype == "one-handed maces") or
			( objectsubtype == "daggers") or
			( objectsubtype == "fist weapons")
		) then return true end
		
		if ( class == "WARRIOR" ) and ( 
			( objectsubtype == "one-handed swords") or
			( objectsubtype == "two-handed swords") or
			( objectsubtype == "one-handed axes") or
			( objectsubtype == "two-handed axes") or
			( objectsubtype == "one-handed maces") or
			( objectsubtype == "two-handed maces") or
			( objectsubtype == "daggers") or
			( objectsubtype == "polearms") or
			( objectsubtype == "fist weapons") or
			( objectsubtype == "staves") or
			( objectsubtype == "crossbows") or
			( objectsubtype == "bows") or
			( objectsubtype == "guns")
		) then return true end
	
		if ( class == "DEATHKNIGHT" ) and ( 
			( objectsubtype == "one-handed swords") or
			( objectsubtype == "two-handed swords") or
			( objectsubtype == "one-handed axes") or
			( objectsubtype == "two-handed axes") or
			( objectsubtype == "one-handed maces") or
			( objectsubtype == "two-handed maces") or
			( objectsubtype == "polearms")
		) then return true end
		
		if ( class == "PALADIN" ) and ( 
			( objectsubtype == "one-handed swords") or
			( objectsubtype == "two-handed swords") or
			( objectsubtype == "one-handed axes") or
			( objectsubtype == "two-handed axes") or
			( objectsubtype == "one-handed maces") or
			( objectsubtype == "two-handed maces") or
			( objectsubtype == "polearms")
		) then return true end
		
		if ( class == "PRIEST" ) and ( 
			( objectsubtype == "staves") or
			( objectsubtype == "wands") or
			( objectsubtype == "daggers") or
			( objectsubtype == "one-handed maces")
		) then return true end
		
		if ( class == "MAGE" ) and ( 
			( objectsubtype == "one-handed swords") or
			( objectsubtype == "staves") or
			( objectsubtype == "daggers") or
			( objectsubtype == "wands")
		) then return true end
		
		if ( class == "WARLOCK" ) and (
			( objectsubtype == "one-handed swords") or
			( objectsubtype == "staves") or
			( objectsubtype == "daggers") or
			( objectsubtype == "wands")
		) then return true end
		
		if ( class == "HUNTER" ) and ( 
			( objectsubtype == "one-handed swords") or
			( objectsubtype == "two-handed swords") or
			( objectsubtype == "one-handed axes") or
			( objectsubtype == "two-handed axes") or
			( objectsubtype == "daggers") or
			( objectsubtype == "polearms") or
			( objectsubtype == "fist weapons") or
			( objectsubtype == "staves") or
			( objectsubtype == "crossbows") or
			( objectsubtype == "bows") or
			( objectsubtype == "guns")
		) then return true end
		
		if ( class == "SHAMAN" ) and (
			( objectsubtype == "staves") or
			( objectsubtype == "one-handed maces") or
			( objectsubtype == "two-handed maces") or
			( objectsubtype == "one-handed axes") or
			( objectsubtype == "two-handed axes") or
			( objectsubtype == "daggers") or
			( objectsubtype == "fist weapons") or
			( objectsubtype == "staves")
		) then return true end
		
		if ( class == "DRUID" ) and (
			( objectsubtype == "one-handed maces") or
			( objectsubtype == "two-handed maces") or
			( objectsubtype == "polearms") or
			( objectsubtype == "daggers") or
			( objectsubtype == "fist weapons") or
			( objectsubtype == "staves")
		) then return true end
	
		if ( class == "ROGUE" ) and (
			( objectsubtype == "daggers") or
			( objectsubtype == "one-handed swords") or
			( objectsubtype == "one-handed axes") or
			( objectsubtype == "one-handed maces") or
			( objectsubtype == "fist weapons") or
			( objectsubtype == "crossbows") or
			( objectsubtype == "bows") or
			( objectsubtype == "guns")
		) then return true end
		
		if ( class == "MONK" ) and (
			( objectsubtype == "one-handed axes") or
			( objectsubtype == "one-handed swords") or
			( objectsubtype == "one-handed maces") or
			( objectsubtype == "polearms") or
			( objectsubtype == "fist weapons") or
			( objectsubtype == "staves")
		) then return true end
		
	end
	
	-- always return false at the end... SO SAYETH ARKAYENRO.
	return false
	
end
